#! /bin/sh
#
#  bootstrap_rpm.sh   install full featured rpm with busybox-rpm
#

/root/scripts/mount_installsource.sh

# Bootstrap rpm of Fedora with busybox rpm
RPM_PATH="/mnt/cdrom/${distri}/RPMS/"
RPM_COMMAND="/bin/busybox rpm -i ${RPM_PATH}"

# Install rpm of Fedora
# This list was created by recursively following the dependencies of rpm
# in FC2: rpm -qR -p rpm-4.3.1-0.3.i386.rpm  and for all of its dependencies
# in FC3: rpm -qR -p rpm-4.3.2-2.i386.rpm  and for all of its dependencies

# echo bootstrap rpm: method=$method version=$version
# read x

case $method in
cdrom|iso|rpms|nfsiso|nfsrpms)
    case $version in
    2)
        ${RPM_COMMAND}tzdata-2003d-2.noarch.rpm
        ${RPM_COMMAND}glibc-common-2.3.3-27.i386.rpm
        ${RPM_COMMAND}libgcc-3.3.3-7.i386.rpm
        ${RPM_COMMAND}setup-2.5.33-1.noarch.rpm
        ${RPM_COMMAND}filesystem-2.2.4-1.i386.rpm
        ${RPM_COMMAND}basesystem-8.0-3.noarch.rpm
        ${RPM_COMMAND}glibc-2.3.3-27.i386.rpm
        ${RPM_COMMAND}bzip2-libs-1.0.2-12.1.i386.rpm
        ${RPM_COMMAND}beecrypt-3.1.0-3.i386.rpm
        ${RPM_COMMAND}zlib-1.2.1.1-2.1.i386.rpm
        ${RPM_COMMAND}popt-1.9.1-0.3.i386.rpm
        ${RPM_COMMAND}elfutils-libelf-0.95-2.i386.rpm
        ${RPM_COMMAND}libtermcap-2.0.8-38.i386.rpm
        ${RPM_COMMAND}mktemp-1.5-7.i386.rpm
        ${RPM_COMMAND}bash-2.05b-38.i386.rpm
        ${RPM_COMMAND}libselinux-1.11.4-1.i386.rpm
        ${RPM_COMMAND}shadow-utils-4.0.3-21.i386.rpm
        ${RPM_COMMAND}db4-4.2.52-3.1.i386.rpm
        ${RPM_COMMAND}rpm-4.3.1-0.3.i386.rpm
	;;
    3)
	# echo
	# echo Bootstrap full featured rpm with busybox-rpm from $method
	# echo press ENTER; read x
	set -x
        ${RPM_COMMAND}tzdata-2004b-2.noarch.rpm 2>/dev/null
        ${RPM_COMMAND}glibc-common-2.3.3-74.i386.rpm 2>/dev/null
        ${RPM_COMMAND}libgcc-3.4.2-6.fc3.i386.rpm 2>/dev/null
        ${RPM_COMMAND}setup-2.5.36-1.noarch.rpm 2>/dev/null
        ${RPM_COMMAND}filesystem-2.3.0-1.i386.rpm 2>/dev/null
        ${RPM_COMMAND}basesystem-8.0-4.noarch.rpm 2>/dev/null
        ${RPM_COMMAND}glibc-2.3.3-74.i386.rpm 2>/dev/null
        ${RPM_COMMAND}bzip2-libs-1.0.2-13.i386.rpm 2>/dev/null
        ${RPM_COMMAND}beecrypt-3.1.0-6.i386.rpm 2>/dev/null
        ${RPM_COMMAND}zlib-1.2.1.2-1.i386.rpm 2>/dev/null
        ${RPM_COMMAND}popt-1.9.1-21.i386.rpm 2>/dev/null
        ${RPM_COMMAND}elfutils-libelf-0.96-1.i386.rpm 2>/dev/null
        ${RPM_COMMAND}termcap-5.4-3.noarch.rpm 2>/dev/null
        ${RPM_COMMAND}libtermcap-2.0.8-39.i386.rpm 2>/dev/null
        ${RPM_COMMAND}mktemp-1.5-10.i386.rpm 2>/dev/null
#        rm /bin/sh
        ${RPM_COMMAND}bash-3.0-17.i386.rpm 2>/dev/null
        ${RPM_COMMAND}libselinux-1.17.14-1.i386.rpm 2>/dev/null
        ${RPM_COMMAND}shadow-utils-4.0.3-37.i386.rpm 2>/dev/null
        ${RPM_COMMAND}rpm-libs-4.3.2-21.i386.rpm 2>/dev/null
        ${RPM_COMMAND}libstdc++-3.4.2-6.fc3.i386.rpm 2>/dev/null
        ${RPM_COMMAND}db4-4.2.52-6.i386.rpm 2>/dev/null
        ${RPM_COMMAND}rpm-4.3.2-21.i386.rpm 2>/dev/null
	;;
    esac
	
    # Use --replacepkgs to avoid reporting an error if a 
    RPM_COMMAND="/bin/rpm -ivh --nodeps --replacepkgs ${RPM_PATH}"
    RPM_INFO="/bin/rpm -qi -p ${RPM_PATH}"
    set +x
    ;;
ftprpms)
set -x
    mkdir /ftptmp

    # set the ftpget-options
    useropt="-u `echo $LOGIN | cut -d: -f1`"
    passopt="-p `echo $LOGIN | cut -d: -f2 | cut -d@ -f1`"
    hostopt="$HOST$PORT"
    pathopt="$FILE_PATH"

    case $version in
    2)
	rpmlist=tzdata-2003d-2.noarch.rpm   \
	    glibc-common-2.3.3-27.i386.rpm  \
	    libgcc-3.3.3-7.i386.rpm         \
	    setup-2.5.33-1.noarch.rpm       \
	    filesystem-2.2.4-1.i386.rpm     \
	    basesystem-8.0-3.noarch.rpm     \
	    glibc-2.3.3-27.i386.rpm         \
	    bzip2-libs-1.0.2-12.1.i386.rpm  \
	    beecrypt-3.1.0-3.i386.rpm       \
	    zlib-1.2.1.1-2.1.i386.rpm       \
	    popt-1.9.1-0.3.i386.rpm         \
	    elfutils-libelf-0.95-2.i386.rpm \
	    libtermcap-2.0.8-38.i386.rpm    \
	    mktemp-1.5-7.i386.rpm           \
	    bash-2.05b-38.i386.rpm          \
	    libselinux-1.11.4-1.i386.rpm    \
	    shadow-utils-4.0.3-21.i386.rpm  \
	    db4-4.2.52-3.1.i386.rpm         \
	    rpm-4.3.1-0.3.i386.rpm
	;;
    3)
	rpmlist=tzdata-2004b-2.noarch.rpm   \
	    glibc-common-2.3.3-74.i386.rpm  \
	    libgcc-3.4.2-6.fc3.i386.rpm     \
	    setup-2.5.36-1.noarch.rpm       \
	    filesystem-2.3.0-1.i386.rpm     \
	    basesystem-8.0-4.noarch.rpm     \
	    glibc-2.3.3-74.i386.rpm         \
	    bzip2-libs-1.0.2-13.i386.rpm    \
	    beecrypt-3.1.0-6.i386.rpm       \
	    zlib-1.2.1.2-1.i386.rpm         \
	    popt-1.9.1-21.i386.rpm          \
	    elfutils-libelf-0.96-1.i386.rpm \
	    termcap-5.4-3.noarch.rpm        \
	    libtermcap-2.0.8-39.i386.rpm    \
	    mktemp-1.5-10.i386.rpm          \
	    bash-3.0-17.i386.rpm            \
	    libselinux-1.17.14-1.i386.rpm   \
	    shadow-utils-4.0.3-37.i386.rpm  \
	    rpm-libs-4.3.2-21.i386.rpm      \
	    libstdc++-3.4.2-6.fc3.i386.rpm  \
	    db4-4.2.52-6.i386.rpm           \
	    rpm-4.3.2-21.i386.rpm
	;;
    esac

    for rpm in $rpmlist
    do
set -x
#	[ $rpm = 'bash-3.0-17.i386.rpm' ] && rm /bin/sh
	echo trying to get $rpm via ftp, press ENTER
	read x
	/bin/busybox ftpget -v $useropt $passopt $hostopt /ftptmp/$rpm $pathopt/$rpm || {
	    echo ftpget failed for $pathopt/$rpm | tee -a $install_log
	    echo press ENTER
	    read x
	    continue
	}
	echo trying to busybox/rpm -i $rpm, press ENTER
	read x
	/bin/busybox rpm -i /ftptmp/$rpm
	rm /ftptmp/$rpm
    done
    rmdir /ftptmp

    RPM_COMMAND="/bin/rpm -ivh --nodeps --replacepkgs FTP://${LOGIN}${HOST}${PORT}${FILE_PATH}"
    ;;
html)
    echo Cannot bootstrap rpm from html-source - exiting
    echo press ENTER
    read x
    return
    ;;
esac

/root/scripts/unmount_installsource.sh
