#! /bin/sh
#
#  call_mk_bootfloppy.tpl
#
#  Processing in newroot context.

# echo "Changing directories."
cd /newroot
PWD=`/bin/pwd`
if [ "$PWD" != "/newroot" ]; then
    echo "Failed to cd to /newroot, exiting. Press ENTER"; read x
    return
fi

echo "Executing pivot_root, making /newroot your new / directory"
[ ! -d oldroot ] && mkdir oldroot
# pivot_root NEWroot PUTold
pivot_root . oldroot || {
    echo "Pivot_root to_/newroot put_/oldroot failed."
    echo "Installation can not continue, exiting. Press ENTER"; read x
    return
}

#  from now on reset context on CTRL-C SIGINT
trap 'cd /oldroot;
      pivot_root . newroot' 2

# echo "Success!"
# If this shell is killed, init respawns /scripts/run_installer.
# But from now on /scripts is located at /oldroot/scripts.
# Try: symlink it to the new / (/newroot)
[ ! -e /scripts ] && ln -s /oldroot/scripts .

chroot . /bin/sh /root/scripts/mk_bootfloppy.sh

# At this point, we lose this shell for the time being.
# It'll be here waiting when we back our way out.
# The script will then finish executing the commands below.

cd /oldroot
# pivot_root NEWroot PUTold
pivot_root . newroot || {
    echo "Pivot_root to_/oldroot put_/newroot failed."
    echo "Installation can not continue, exiting. Press ENTER"; read x
    return
}

# clear the trap
trap '' 2

# echo press ENTER; read x
