#! /bin/sh
#
#  config_new.sh

# Set up networking if they installed network tools. 
# Without this line, the interfaces won't come up.

if [ "$NETWORK" -eq "1" ]; then
    echo "NETWORKING=yes" > /etc/sysconfig/network

    if [ -z ${hostname} ]; then
    echo -n "Enter a host name for this machine: "
    read hostname
    fi
    echo HOSTNAME=$hostname >> /etc/sysconfig/network

#     if [ -z ${gateway} ]; then
#     echo -n "If you are on a network, enter a gateway IP: "
#     read gateway
#     fi
#     echo GATEWAY=$gateway >> /etc/sysconfig/network 
fi

# Run authconfig. Enable md5 and shadow.
/usr/sbin/authconfig --kickstart --enablemd5 --enableshadow > /dev/null 2>&1

echo "Please set a root password:"
    
/usr/bin/passwd
echo

# Create a non-root user account.
have_user=0
while [ "$have_user" -ne "1" ]
  do
  echo
  echo "Please create a non-root user account, this is required!"
  echo
  echo -n "Please enter a login name: "
  read login_name
  if [ -n ${login_name} ]; then
      have_user=1
      /usr/sbin/useradd ${login_name}
      echo
      echo -n "Please enter ${login_name}'s full name: "
      read full_name
      if [ -n "${full_name}" ]; then
      /usr/bin/chfn -f "${full_name}" ${login_name}
      fi
  fi
done

# Set a password for the new user.
echo
echo "Please set a password for ${login_name}."
/usr/bin/passwd ${login_name}
echo

if [ "$packprefix" = 'all' ]; then
    echo kudzu needs /etc/modprobe.conf
    [ ! -f /etc/modprobe.conf ] && cp /etc/modprobe.conf.dist /etc/modprobe.conf
fi

# Create /etc/sysconfig/keyboard, use same as for installation
keyboard=/etc/sysconfig/keyboard

[ -f $keyboard ] && mv $keyboard $keyboard.orig
cat <<EOF >> $keyboard
KEYBOARDTYPE="pc"
EOF

# echo "keymap is <${keymap}>"
# read x

case "$keymap" in
"de.map")
    echo 'KEYTABLE="de-latin1-nodeadkeys"' >>$keyboard
    ;;
"fr.map")
    echo 'KEYTABLE="fr-latin1"' >>$keyboard
    ;;
"it.map")
    echo 'KEYTABLE="it"' >>$keyboard
    ;;
*)
    echo 'KEYTABLE="us"' >>$keyboard
    ;;
esac
