#! /bin/sh
#
#  prepare_newroot.sh
#
#  We are in /oldroot context and copy all necessary files
#  to /newroot

echo "Creating needed directories for the new system ..."
[ ! -d /newroot ] && mkdir /newroot || rm -rf /newroot
echo "This is the /newroot partition.
This file can be removed." >/newroot/_newroot_partition_
mkdir -p /newroot/boot/grub
mkdir -p /newroot/root/scripts
mkdir -p /newroot/mnt/floppy
mkdir -p /newroot/etc
mkdir -p /newroot/etc/sysconfig
mkdir -p /newroot/etc/rpm
mkdir -p /newroot/var/tmp
mkdir -p /newroot/usr/local/bin

# Create the /etc/fstab file.
FSTAB=/newroot/etc/fstab

cat >>$FSTAB <<EOF
$ROOT_DEV       /           $fstype    defaults        1 1
none        /sys            sysfs   defaults        0 0
none        /dev/pts        devpts  gid=5,mode=620  0 0
none        /proc           proc    defaults        0 0
none        /dev/shm        tmpfs   defaults        0 0
/dev/fd0        /mnt/floppy     auto    noauto,owner    0 0
EOF

for swap in $SWAP_DEV
do
    echo "$swap     swap       swap    defaults        0 0"  >> $FSTAB
done

if [ -e fstab ]; then
    cat fstab >> $FSTAB
    rm -f fstab
fi

if [ -n "$CDROM_DEV" ]; then
    echo "$CDROM_DEV    /mnt/cdrom      iso9660 noauto,owner,ro 0 0" >> $FSTAB
fi

# Create /etc/sysconfig/i18n
i18n=/newroot/etc/sysconfig/i18n

cat <<EOF >> $i18n
LANG="en_US"
SUPPORTED="en_US.UTF-8:en_US:en"
SYSFONT="latarcyrheb-sun16"
EOF

# echo /newroot/etc/sysconfig/keyboard configured
# echo press ENTER
# read x

echo "Copying executables and config files..."

mv $install_log /newroot/root/scripts/
cp /scripts/*.sh /newroot/root/scripts/
cp /scripts/slinky* /newroot/root/scripts/
# cp /scripts/xorg* /newroot/root/scripts/
cp -a /scripts/3 /newroot/root/scripts/
cp -a /bin /newroot/
cp -a /sbin /newroot/
cp -a /usr /newroot/
cp -a /var /newroot/
cp -a /dev /newroot/
cp -a /boot /newroot/
cp -a /lib /newroot/
cp /etc/hosts  /newroot/etc/
cp /etc/resolv.conf /newroot/etc/

grep /proc /etc/mtab > /newroot/etc/mtab
grep newroot /etc/mtab | sed -e 's-newroot--' -e s'-//-/-' >> /newroot/etc/mtab
# echo Thats /newroot/etc/fstab======================
# cat /newroot/etc/fstab
# echo ==============================================
# echo Thats /newroot/etc/mtab=======================
# cat /newroot/etc/mtab
# echo ==============================================

# echo press ENTER; read x
