#! /bin/sh
#
#  select_method.sh   Select your installation methode

 
# Let the user select the install method.
# If not defined in the config file ask.

while :; do
dialog --no-collapse --title 'Choose installation method' --menu "
     I You get | Source on harddisk | Source on CD I
     I source  |    in format       |              I
     I from:   | Fedora |   rpms**) |   Fedora     I
     I         |  iso*) |           |     iso      I
     I---------------------------------------------I
     I local   |    iso |      rpms |    cdrom     I
     I---------|--------+-----------I--------------I
     I nfs     | nfsiso |   nfsrpms I
     I---------|--------+-----------I
     I ftp     |   n/a  |   ftprpms I
     I------------------------------I
     *) ISOs are found, if placed in the top-level-directory of
        a local harddisk-partion or nfs-export-directory.
     **)RPMs are found, if placed in the $distri/RPMS directory.
" 22 70 1 1 cdrom 2 iso 3 rpms 4 nfsiso 5 nfsrpms 6 ftprpms 2>/tmp/dialog.inp
method=`cat /tmp/dialog.inp`
case "$method" in
1) method=cdrom
   ;;
2) method=iso
   ;;
3) method=rpms
   ;;
4) method=nfsiso
   ;;
5) method=nfsrpms
   ;;
6) method=ftprpms
   ;;
*) ;;
esac

    echo User selected $method install type. >> $install_log
    
    # Make sure we have a valid install type, if not, default to cdrom.
    
    if [ -z "$method" ]; then
	method='cdrom'
	echo "Defaulting to CDROM install."
    fi
    if [ "$method" != "iso" ] && [ "$method" != "rpms" ] &&\
        [ "$method" != "nfsiso" ]  && [ "$method" != "nfsrpms"  ] &&\
        [ "$method" != "ftprpms"  ] &&\
        [ "$method" != "cdrom" ]; then
dialog --no-collapse --msgbox "

        Your input <$method> is not recognized, please try again

" 0 0
        continue
    fi
    break
done
export method

case $method in
http)
    dialog --no-collapse --msgbox "

    Sorry, but install via <$method> is no longer supported - exiting

" 0 0
    exit 1
    ;;

ftprpms)
    # FTPrpm installs. No need for disk swaps here.
    # All of the needed rpms should be in one directory.

# temporary for fzk
# modprobe 3c59x
/scripts/pcmcia.sh start
ifconfig eth0 10.0.0.3

    while :
    do
	echo
        echo "You chose to install rpms via a ftp server."
        echo "The network connection must be up. If this is not"
        echo "the case, please quit, and bring up the network."
        echo "I need to know the login, server and path to the RPMS."
        echo "USER:PASSWORD is not required for anonymous login."
        echo
        echo "If required, please enter your login, in the form"
        echo -n "of [ USER:PASSWORD ]: "
        read LOGIN
        echo
        if [ -n "$LOGIN" ]; then
            LOGIN=${LOGIN}@
        fi
        echo -n "Please enter the IP address of the host: "
        read HOST
        echo
        echo -n "If nonstandard, please enter the port: "
        read PORT
        echo
        if [ -n "$PORT" ]; then
            PORT=:${PORT}
        fi
        echo "Please enter the full /path/to/the/RPMS/ directory."
        echo
        echo -n "Path, including the leading and trailing '/': "
        read FILE_PATH
        echo
        echo "Testing connectivity with ping ..."
        ping $HOST
        if [ $? -eq 0 ]; then
            echo "Success!"
            echo Ping host: Success >> $install_log
	    break
        else
            echo "Failed to ping the selected host. If this is unexpected, you"
            echo "should quit the install, and verify that your network is up."
            echo Ping host: Failed >> $install_log
        fi
    done
    echo "remote login (user:password): ${HOST}${PORT}${FILE_PATH}" >> $install_log
    export LOGIN HOST PORT FILE_PATH
    ;;

nfsrpms )
    # NFSrpms Installs.
    # Currently requires all rpms to be in the same exported directory.
    # Files must be in $distri/RPMS in the exported filesystem.

## nfs is statically compiled into the kernel (cannot load lockd.ko dynamically)
#     /sbin/modprobe nfs > /dev/null 2>&1 || {
#         echo
#         echo "Kernel NFS modules failed to load." | tee -a $install_log
#         echo "Unable to continue, exiting."
#         exit 1
#   echo press ENTER
#   read x
#     }

# temporary for fzk
# modprobe 3c59x
/scripts/pcmcia.sh start
ifconfig eth0 10.0.0.3

    while :
    do
	echo
        echo "You choose to install RPMs via a nfs server."
        echo "You need to provided the following:"
        echo
        echo "1) setup networking on this local host"
        echo "2) setup nfs on a server and know the name of the exported directory"
        echo "3) copy all rmps of all CDs of $distri/$version into the directory"
        echo "   [exported directory]/$distri/RPMS"
        echo
        echo "About to mount the exported directory on /mnt/cdrom."
        echo "Please enter the name of the exported directory,"
        echo -n "In the form of ip:/exported/path "
        read exportedfs
        echo
        echo "Attempting to mount $exportedfs on /mnt/cdrom." | tee -a $install_log
        echo "Using read only and nolock mount options."
        /bin/mount -t nfs -o ro,nolock "$exportedfs" /mnt/cdrom 2>&1 | tee -a $install_log || {
            echo
            echo "NFS mount of $exportedfs failed." | tee -a $install_log
	    echo "In order to get this working:"
	    echo "1) setup networking on this local host (modprobe, ifconfig)"
	    echo "2) export a directory on the server see /etc/exports"
	    echo "3) setup nfs on your server (start nfsd)"
	    echo "4) copy all rpms of $distri/$version to directory $distri/RPMS"
	    echo press ENTER
	    read x
	    continue
        }
        echo
        echo "First step OK"
        echo "<$exportedfs> now mounted on /mnt/cdrom"
        mount | grep /mnt/cdrom
        if [ -d /mnt/cdrom/$distri/RPMS ]; then
	    echo
	    echo "Second step OK"
	    echo
            echo "Located </mnt/cdrom/$distri/RPMS> directory! success."
	    echo
	    sleep 1
	    break
        else
            echo
	    echo "Second step FAILED"
            echo "Failed to locate </mnt/cdrom/$distri/RPMS/>."
	    echo "You have to create the directory <$exportedfs/$distri/RPMS>"
	    echo "and copy all rpms of all <$distri/$version> CDs into it."
	    echo "press ENTER"
	    read x
	    umount /mnt/cdrom
	fi
    done
    export exportedfs
    umount /mnt/cdrom
    echo press ENTER
    read x
    ;;

iso )
    # iso installs

    have_iso=0
    while [ "$have_iso" -ne "1" ]
    do
        while :
        do
            echo
            echo "You chose to install ISOs from a local harddisk."
            echo "I need to know what partition the iso is located on."
            echo "For example, hdb1, hdb2, hdc1, etc. This MUST NOT be"
            echo "a partition that will be part of the install."
            echo
            echo -n "What partition is the iso located on? : "
            read iso_part
            echo
            echo "Trying to mount /dev/${iso_part} on /mnt/loop"
            umount /mnt/loop
            mkdir -p /mnt/loop >/dev/null 2>&1
            mount /dev/${iso_part} /mnt/loop || {
		echo "Failed to mount /dev/${iso_part} on /mnt/loop." | tee -a $install_log
		echo "Try again.  If you are stuck here, RESET and restart from begin"
		echo press ENTER
		read x
		umount /mnt/loop > /dev/null 2>&1
		continue
            }
            break
        done
        while :
        do
            echo
            echo "Please include the /path/to/the/file.iso if"
            echo "the file does not reside in the root directory."
            echo "The usual name for Fedora FC$version disc1 is <$fc_disc1>"
            echo
            echo "Enter path and name of the iso file? "
            [ ! -z "$fc_disc1" ] && echo -n "or ENTER for [ $fc_disc1 ] "
            read iptfilename
            [ -z "$iso_file" ] && iso_file="$fc_disc1" || iso_file="$iptfilename"
            mount -o loop,ro -t iso9660 /mnt/loop/${iso_file} /mnt/cdrom || {
		echo "Failed to mount /dev/${iso_part}/${iso_file} on /mnt/cdrom." | tee -a $install_log
		echo "Try again.  If you are stuck here, RESET and restart from begin"
		echo press ENTER
		read x
		umount /mnt/cdrom > /dev/null 2>&1
		continue
            }
            export iso_file
            break
        done
    
        if [ -d /mnt/cdrom/$distri/RPMS ]; then
 	    echo
            echo "Located the $distri/RPMS/ directory! success."
	    echo
            have_iso=1
            sleep 2
            umount /mnt/cdrom > /dev/null 2>&1
        fi
    
        umount /mnt/cdrom > /dev/null 2>&1
    
        echo "Trying to mount Fedora ISOs disc2-4"
        stem=`echo "$iso_file" | sed -e 's/-disc1.iso//'`
        for i in 2 3 4
        do
            mount -o loop,ro -t iso9660 /mnt/loop/${stem}-disc$i.iso /mnt/cdrom && {
		echo "Will also use ${stem}-disc$i.iso for this installation" | tee -a $install_log
		umount /mnt/cdrom > /dev/null 2>&1
            } || echo "${stem}-disc$i.iso couldn't be mounted"
        done
    
        umount /mnt/cdrom > /dev/null 2>&1
        umount /mnt/loop > /dev/null 2>&1
    done
    export iso_part iso_file
    echo
    echo "You sucessfully selected iso-source $iso_part/$iso_file for installation"
    echo
    echo press ENTER
    read x
    echo
    ;;

nfsiso )
    # nfsiso installs
    # Currently requires all ISOs to be in the same exported directory.
    # Files should be in the top-level-directory in the exported filesystem.

## nfs is statically compiled into the kernel (cannot load lockd.ko dynamically)
#     /sbin/modprobe nfs > /dev/null 2>&1 || {
#         echo
#         echo "Kernel NFS modules failed to load." | tee -a $install_log
#         echo "Unable to continue, exiting."
#         exit 1
#   echo press ENTER
#   read x
#     }

# temporary for fzk
# modprobe 3c59x
/scripts/pcmcia.sh start
ifconfig eth0 10.0.0.3

    while :
    do
	echo
        echo "You choose to install ISOs via a nfs server."
        echo "You need to provided the following:"
        echo
        echo "1) setup networking on this local host"
        echo "2) setup nfs on a server and know the name of the exported directory"
        echo "3) copy all $distri ISOs into this directory [exported directory]"
        echo
        echo "About to mount the exported directory on /mnt/cdrom."
        echo "Please enter the name of the exported directory,"
        echo -n "In the form of ip:/exported/path "
        read exportedfs
        echo
        echo "Attempting to mount $exportedfs on /mnt/cdrom." | tee -a $install_log
        echo "Using read only and nolock mount options."
        /bin/mount -t nfs -o ro,nolock "$exportedfs" /mnt/cdrom 2>&1 | tee -a $install_log || {
            echo
            echo "NFS mount of $exportedfs failed." | tee -a $install_log
	    echo "In order to get this working:"
	    echo "1) setup networking on this local host (modprobe, ifconfig)"
	    echo "2) export a directory on the server see /etc/exports"
	    echo "3) setup nfs on your server (start nfsd)"
	    echo "4) copy all $distri ISOs into this directory [exported directory]"
	    echo press ENTER
	    read x
	    continue
        }
        echo
        echo "First step OK"
        echo "<$exportedfs> now mounted on /mnt/cdrom"
        mount | grep /mnt/cdrom

        while :
        do
            echo
            echo "Now include the /path/to/the/file.iso if"
            echo "the file does not reside in the root directory."
            echo "The usual name for Fedora FC$version disc1 is <$fc_disc1>"
            echo
            echo "Enter path and name of the iso file? "
            [ ! -z "$fc_disc1" ] && echo -n "or ENTER for [ $fc_disc1 ] "
            read iptfilename
            [ -z "$iptfilename" ] && iso_file="$fc_disc1" || iso_file="$iptfilename"

	    if [ -r /mnt/cdrom/$iso_file ]; then
		echo
		echo "Located the <$exportedfs/$iso_file>! success."
		echo
		have_iso=1
		sleep 2
		echo "Trying to find Fedora ISOs disc2-4"
		stem=`echo "$iso_file" | sed -e 's/-disc1.iso//'`
		for i in 2 3 4
		do
		    [ -r /mnt/cdrom/$stem-disc$i.iso ] && {
			echo "Will also use $exportedfs/${stem}-disc$i.iso for this installation" | tee -a $install_log
		    } || echo "$exportedfs/${stem}-disc$i.iso couldn't be located"
		done
		break
	    else
		echo "$distri ISO <$iso_file> not found, try again"
		echo press ENTER; read x
	    fi
	done
	break
    done
    export exportedfs iso_file
    umount /mnt/cdrom
    echo press ENTER
    read x
    ;;

rpms )
    # Local rpm files on the hard drive.
    # RPMs must be in $distri/RPMS in the root of the partition.

    have_rpms=0
    while [ "$have_rpms" -ne "1" ]
    do
	echo "You chose to install from rpms located on a hard drive."
	echo "I need to know what partition the files are located on."
	echo "For example, hdb1, hdb2, hdc1, etc. This MUST NOT be"
	echo "a partition that will be part of the install."
	echo
	echo -n "What partition is the $distri/RPMS directory located on? : "
	read iso_part
	echo
	echo "Trying to mount /dev/${iso_part}..."
	mount /dev/${iso_part} /mnt/cdrom || {
	    echo
	    echo "Failed to mount /dev/${iso_part}." | tee -a $install_log
	    echo
	    have_rpms=0
	}
	if [ -d /mnt/cdrom/$distri/RPMS ]; then
 	    echo
            echo "Located the $distri/RPMS/ directory! success."
	    echo
            have_rpms=1
            sleep 2
	fi
	umount /mnt/cdrom
    done
    export iso_part
    echo
    ;;

* )
    # cdrom installs (default)
    # Find the cdrom, and hope that the entry in /proc is correct.

    # cd_device=`grep "drive name" /proc/sys/dev/cdrom/info | cut -d : -f 2 | cut -f 3`
    cd_device=`grep cdrom /proc/ide/hd?/media | head -1 | cut -d/ -f4`
    echo CD probe=$cd_device >> $install_log

    have_device=0
    while [ "$have_device" -ne "1" ]
    do
    case "$cd_device" in
    hda) CDROM_DEV=/dev/hda
        have_device=1
        export CDROM_DEV
        ;;
    hdb) CDROM_DEV=/dev/hdb
        have_device=1
        export CDROM_DEV
        ;;
    hdc) CDROM_DEV=/dev/hdc
        have_device=1
        export CDROM_DEV
        ;;
    hdd) CDROM_DEV=/dev/hdd
        have_device=1
        export CDROM_DEV
        ;;
    cdrom) CDROM_DEV=/dev/cdrom
        have_device=1
        export CDROM_DEV
        ;;
    esac

    if [ -z "$CDROM_DEV" ]; then
	dialog --no-collapse --inputbox "
    I wasn't able to locate your cdrom drive.
    The 'cdrom' entry below should be used only if
    your drive is nonstandard, and you have created
    a link from /dev/cdrom to the actual device.

    Please enter the device that represents
    your cdrom device. [ hda hdb hdc hdd cdrom ]:
" 12 70 '' 2>/tmp/dialog.ipt
	CDROM_DEV=`cat /tmp/dialog.ipt`
    fi

	dialog --msgbox "
    I will try to use <$CDROM_DEV> as your cd drive.
    You will have the opportunity to change this
    later in the install, if need be.
" 12 70
    done

    echo CDROM_DEV=$CDROM_DEV >> $install_log
    ;;

esac
