#!/bin/bash

. version.h

mkisofsopts="-J -L -N -r -T -v -x ./lost+found"
vol_id="-A ${archive_name} -V ${archive_name}"

SLINKYDIR="rule_iso"
BOOTIMG="images/${version}-disk1.img"
BOOTCAT="boot.cat"

rm -rf $SLINKYDIR/images/*
rm -rf $SLINKYDIR/install/*
rm -rf $SLINKYDIR/PCMCIA

# FIXME: 0.4.03: PCMCIA is not prepared by now
cp -a PCMCIA $SLINKYDIR
cp -a docs/* ${SLINKYDIR}

mkdir -p ${SLINKYDIR}/images/
cp -a slinky-images/${version}/${version}-disk1.img ${SLINKYDIR}/images/
# cp -a slinky-images/${version}/${version}-disk2.img ${SLINKYDIR}/images/
# FIXME: 0.4.03: PCMCIA is not prepared by now
cp -a slinky-images/${version}/pcmcia.img ${SLINKYDIR}/images/

mkdir -p ${SLINKYDIR}/install/stage2
cp -a DISK2/* ${SLINKYDIR}/install/stage2

mkisofs $vol_id $mkisofsopts -b $BOOTIMG -c $BOOTCAT\
   -o slinky-images/${version}/${version}.iso $SLINKYDIR

cd slinky-images/${version}/
md5sum *.img > MD5SUMS
md5sum *.iso >> MD5SUMS

exit
